"""
本代码由[Tkinter布局助手]生成
官网:https://www.pytk.net
QQ交流群:788392508
在线反馈:https://support.qq.com/product/618914
"""
from tkinter import *
from tkinter.ttk import *
class WinGUI(Tk):
    def __init__(self):
        super().__init__()
        self.__win()
        self.tk_label_lqcd61xx = self.__tk_label_lqcd61xx(self)
        self.tk_button_login = self.__tk_button_login(self)
        self.tk_input_account = self.__tk_input_account(self)
        self.tk_label_lqcd6nu4 = self.__tk_label_lqcd6nu4(self)
        self.tk_input_password = self.__tk_input_password(self)
    def __win(self):
        self.title("Tkinter布局助手代码演示")
        # 设置窗口大小、居中
        width = 600
        height = 500
        screenwidth = self.winfo_screenwidth()
        screenheight = self.winfo_screenheight()
        geometry = '%dx%d+%d+%d' % (width, height, (screenwidth - width) / 2, (screenheight - height) / 2)
        self.geometry(geometry)
        
        self.resizable(width=False, height=False)
        
    def scrollbar_autohide(self,vbar, hbar, widget):
        """自动隐藏滚动条"""
        def show():
            if vbar: vbar.lift(widget)
            if hbar: hbar.lift(widget)
        def hide():
            if vbar: vbar.lower(widget)
            if hbar: hbar.lower(widget)
        hide()
        widget.bind("<Enter>", lambda e: show())
        if vbar: vbar.bind("<Enter>", lambda e: show())
        if vbar: vbar.bind("<Leave>", lambda e: hide())
        if hbar: hbar.bind("<Enter>", lambda e: show())
        if hbar: hbar.bind("<Leave>", lambda e: hide())
        widget.bind("<Leave>", lambda e: hide())
    
    def v_scrollbar(self,vbar, widget, x, y, w, h, pw, ph):
        widget.configure(yscrollcommand=vbar.set)
        vbar.config(command=widget.yview)
        vbar.place(relx=(w + x) / pw, rely=y / ph, relheight=h / ph, anchor='ne')
    def h_scrollbar(self,hbar, widget, x, y, w, h, pw, ph):
        widget.configure(xscrollcommand=hbar.set)
        hbar.config(command=widget.xview)
        hbar.place(relx=x / pw, rely=(y + h) / ph, relwidth=w / pw, anchor='sw')
    def create_bar(self,master, widget,is_vbar,is_hbar, x, y, w, h, pw, ph):
        vbar, hbar = None, None
        if is_vbar:
            vbar = Scrollbar(master)
            self.v_scrollbar(vbar, widget, x, y, w, h, pw, ph)
        if is_hbar:
            hbar = Scrollbar(master, orient="horizontal")
            self.h_scrollbar(hbar, widget, x, y, w, h, pw, ph)
        self.scrollbar_autohide(vbar, hbar, widget)
    def __tk_label_lqcd61xx(self,parent):
        label = Label(parent,text="账号",anchor="center", )
        label.place(x=103, y=64, width=50, height=30)
        return label
    def __tk_button_login(self,parent):
        btn = Button(parent, text="登录", takefocus=False,)
        btn.place(x=129, y=349, width=356, height=30)
        return btn
    def __tk_input_account(self,parent):
        ipt = Entry(parent, )
        ipt.place(x=179, y=66, width=329, height=30)
        return ipt
    def __tk_label_lqcd6nu4(self,parent):
        label = Label(parent,text="密码",anchor="center", )
        label.place(x=103, y=136, width=50, height=30)
        return label
    def __tk_input_password(self,parent):
        ipt = Entry(parent, )
        ipt.place(x=179, y=139, width=329, height=30)
        return ipt
class Win(WinGUI):
    def __init__(self, controller):
        # 窗口实例, 接收控制器实例
        self.ctl = controller
        super().__init__()
        self.__event_bind()
        
        # 此处将窗口的示例,传递给窗口控制器
        self.ctl.init(self)

    def __event_bind(self):
        """
        这里是给组件绑定事件
        组件绑定的事件来自 self.ctl 窗口控制器中
        """
        self.tk_button_login.bind('<Button-1>',self.ctl.on_login)
        pass
if __name__ == "__main__":
    win = WinGUI()
    win.mainloop()